Unit SF77R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF16_p;

procedure SF77R(X :Real; GRAN1 :Real; GRAN2 :Real; var FX :Real;
                var IER :Integer);

implementation

procedure SF77R(X :Real; GRAN1 :Real; GRAN2 :Real; var FX :Real;
                var IER :Integer);
var
RAB :Real;
label
_10,_20,_30,_40,_50,_60,_70;
begin

IER  := 0;
RAB  := GRAN1 - GRAN2;
if ( RAB ) < 0
 then goto _10
 else if ( RAB ) > 0
       then goto _40
       else goto _30;
_10:
{      GRAN1.LT.GRAN2 }

if ( X  <  0 ) 
 then goto _60;
if ( X  >  0.5 ) 
 then goto _20;

{      .LE.X .LE..5 }

FX  := GRAN1 - RAB*Sqrt(X*0.5);
goto _70;
_20:
if ( X  >  1 ) 
 then goto _60;

{      .5.LT. X .LE.1 }

FX  := GRAN2 + RAB*Sqrt((1.0-X)*0.5);
goto _70;
_30:

{      GRAN1.EQ.GRAN2 }

FX  := GRAN1;
goto _70;
_40:

{      GRAN1.GT.GRAN2 }

if ( X  <  0 ) 
 then goto _60;
if ( X  >  0.5 ) 
 then goto _50;

{      .LE. X.LE..5 }

FX  := GRAN2 + RAB*Sqrt(X*0.5);
goto _70;
_50:
if ( X  >  1 ) 
 then goto _60;

{      .5.LE. X .LE.1 }

FX  := GRAN1 - RAB*Sqrt((1.0-X)*0.5);
goto _70;
_60:
IER  := 66;
FX  := 0.0;
UTSF16(IER,6);
_70:
end;

end.
